#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <cstdlib>

#include "search_puzzle.hpp"

using namespace std;

/* io[N̔Ֆʂ̌^ƃNX` */
// }X̕\
enum Line : int {
    V = -1, // 
    H = -2, // 
    UL = -3, //
    UR = -4,  // 
    LL = -5, // 
    LR = -6, // 
    None = 0, // 
    // ȍ~̐͐̂̂\
};

// Ֆʂ̌^
using NumberLinkBoard = vector<vector<int>>;

/* io[N߂̃NX */
// ev[gNX̉Čp
class NumberLink : public Puzzle<NumberLinkBoard>{
private:
    // Ֆʂ[ɈᔽĂȂ
    bool checkCompliance(const NumberLinkBoard &board);
    // ՖʂĂ邩
    bool checkSolved(const NumberLinkBoard &board);
    // \Ȏ̔ՖʑSĂi[L[Ԃ
    deque<NumberLinkBoard> getNextBoards(const NumberLinkBoard &board);
    // A-starTɗpf(x)̒l擾
    int getAStarValue(const NumberLinkBoard &board);
protected:
    int xsize; // Ֆʂ̉̑傫
    int ysize; // Ֆʂ̏c̑傫
    multimap<int, pair<int, int> > places; // ̏ꏊ
public:
    // ̔ՖʂpăCX^X
    NumberLink(const NumberLinkBoard &initial_board);
    // Ֆʂ\
    void showBoard(void);
    void showBoard(const NumberLinkBoard &board);
};

// ̔ՖʂpăCX^X
NumberLink::NumberLink(const NumberLinkBoard &initial_board) : Puzzle(initial_board)
{
    /* Ֆʂ̃TCYAۑ */
    ysize = initial_board.size();
    if (ysize == 0){
        cout << "Ֆʂ̃TCYł\n";
        return;
    }
    xsize = initial_board[0].size();
    if (xsize == 0){
        cout << "Ֆʂ̃TCYł\n";
        return;
    }
    for (auto &row : initial_board){
        if (static_cast<int>(row.size()) != xsize){
            cout << "Ֆʂ̃TCYł\n";
            return;
        }
    }
    /* ̑g傤2ɂȂĂ邩 */
    for (int y = 0; y < ysize; y++){
        for (int x = 0; x < xsize; x++){
            auto square = initial_board[y][x];
            if (square > 0) places.insert(make_pair(square, make_pair(y, x)));
        }
    }
    for (auto &place : places){
        if (places.count(place.first) != 2){
            cout << "yAɂȂĂ܂\n";
            return;
        }
    }
}

/* H */
enum Direction : int {
    Upper = 1,
    Lower,
    Left,
    Right
};

/* Ֆʂ[ɈᔽĂȂ */
bool NumberLink::checkCompliance(const NumberLinkBoard &board)
{
    /* Ֆʂ̒[ɂ͂ݏoĂȂ */
    for (auto &square : board[0]){ // s
        if (square == Line::V || square == Line::LL || square == Line::LR) return false;
    }
    for (auto &square : board[ysize - 1]){ // ŏIs
        if (square == Line::V || square == Line::UL || square == Line::UR) return false;
    }
    for (int y = 0; y < ysize; y++){ // SĂ̍s
        // [
        auto &leftend = board[y][0];
        if (leftend == Line::H || leftend == Line::UR || leftend == Line::LR) return false;
        // E[
        auto &rightend = board[y][xsize - 1];
        if (rightend == Line::H || rightend == Line::UL || rightend == Line::LL) return false;
    }
    /* rő̐ɎՂĂȂ */
    for (int y = 0; y < ysize; y++){
        for (int x = 0; x < xsize; x++){
            int upper, lower, left, right; // ̏ꏊ̎̃}X̒gi݂ꍇ̂݁j
            if (y > 0) upper = board[y - 1][x];
            if (y < ysize - 1) lower = board[y + 1][x];
            if (x > 0) left = board[y][x - 1];
            if (x < xsize - 1) right = board[y][x + 1];
            switch (board[y][x]){ // ̐̏ꏊ
            case Line::V:
                if (upper == Line::H || upper == Line::LL || upper == Line::LR) return false;
                if (lower == Line::H || lower == Line::UL || lower == Line::UR) return false;
                break;
            case Line::H:
                if (left == Line::V || left == Line::UR || left == Line::LR) return false;
                if (right == Line::V || right == Line::UL || right == Line::LL) return false;
                break;
            case Line::UL:
                if (lower == Line::H || lower == Line::UL || lower == Line::UR) return false;
                if (right == Line::V || right == Line::UL || right == Line::LL) return false;
            case Line::UR:
                if (lower == Line::H || lower == Line::UL || lower == Line::UR) return false;
                if (left == Line::V || left == Line::UR || left == Line::LR) return false;
                break;
            case Line::LL:
                if (upper == Line::H || upper == Line::LL || upper == Line::LR) return false;
                if (right == Line::V || right == Line::UL || right == Line::LL) return false;
                break;
            case Line::LR:
                if (upper == Line::H || upper == Line::LL || upper == Line::LR) return false;
                if (left == Line::V || left == Line::UR || left == Line::LR) return false;
                break;
            default:
                break;
            }
        }
    }
    /* SĂ̐ɂ */
    for (auto &place : places){
        const int num = place.first;
        const int y = place.second.first;
        const int x = place.second.second;
        Direction dir; // H
        int y2, x2; // ̎̏ꏊ
        int count = 0; // ̐oĂ̐
        bool jailed = true; // ̐߂Ă邩ǂ̃tO
        if (y > 0){
            auto &square = board[y - 1][x];
            if (square == Line::V || square == Line::UL || square == Line::UR){
                count++;
                y2 = y - 1;
                x2 = x;
                dir = Direction::Upper;
                jailed = false;
            }else if (square == Line::None){
                jailed = false;
            }
        }
        if (y < ysize - 1){
            auto &square = board[y + 1][x];
            if (square == Line::V || square == Line::LL || square == Line::LR){
                count++;
                y2 = y + 1;
                x2 = x;
                dir = Direction::Lower;
                jailed = false;
            }else if (square == Line::None){
                jailed = false;
            }
        }
        if (x > 0){
            auto &square = board[y][x - 1];
            if (square == Line::H || square == Line::UL || square == Line::LL){
                count++;
                y2 = y;
                x2 = x - 1;
                dir = Direction::Left;
                jailed = false;
            }else if (square == Line::None){
                jailed = false;
            }
        }
        if (x < xsize - 1){
            auto &square = board[y][x + 1];
            if (square == Line::H || square == Line::UR || square == Line::LR){
                count++;
                y2 = y;
                x2 = x + 1;
                dir = Direction::Right;
                jailed = false;
            }else if (square == Line::None){
                jailed = false;
            }
        }
        if (jailed) return false; // oȂȂĂƂ
        if (count > 1){ // 2{ȏoĂƂ
            return false;
        }else if (count == 1){ // 1̐1{oĂƂ
            /* HĂAʂ̐⌳̏ꏊɌqĂȂ`FbN */
            bool loopflag = true; // [v𑱂邩ǂ̃tO
            while (loopflag){
                if (!(y2 > -1 && y2 < ysize && x2 > -1 && x2 < xsize)) return false;
                switch(board[y2][x2]){ // HĂ̏ꏊ
                case Line::V:
                    if (dir == Direction::Upper){
                        y2--;
                    }else if (dir == Direction::Lower){
                        y2++;
                    }
                    break;
                case Line::H:
                    if (dir == Direction::Left){
                        x2--;
                    }else if (dir == Direction::Right){
                        x2++;
                    }
                    break;
                case Line::UL:
                    if (dir == Direction::Upper){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::UR:
                    if (dir == Direction::Upper){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::LL:
                    if (dir == Direction::Lower){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::LR:
                    if (dir == Direction::Lower){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::None:
                    loopflag = false;
                    break;
                default: // ̂Ƃ
                    // ʂ̐ɌqĂƂ
                    if (board[y2][x2] != num) return false;
                    // ̐ɖ߂ĂƂ
                    if (y2 == y && x2 == x) return false;
                    loopflag = false;
                    break;
                }
            }
        }
    }
    return true;
}

/* ՖʂĂ邩 */
bool NumberLink::checkSolved(const NumberLinkBoard &board)
{
    /* SĂ̐ɂ */
    for (auto &place : places){
        const int num = place.first;
        const int y = place.second.first;
        const int x = place.second.second;
        Direction dir; // H
        int y2, x2; // ̎̏ꏊ
        int count = 0; // ̐oĂ̐
        if (y > 0){
            auto &square = board[y - 1][x];
            if (square == Line::V || square == Line::UL || square == Line::UR){
                count++;
                y2 = y - 1;
                x2 = x;
                dir = Direction::Upper;
            }
        }
        if (y < ysize - 1){
            auto &square = board[y + 1][x];
            if (square == Line::V || square == Line::LL || square == Line::LR){
                count++;
                y2 = y + 1;
                x2 = x;
                dir = Direction::Lower;
            }
        }
        if (x > 0){
            auto &square = board[y][x - 1];
            if (square == Line::H || square == Line::UL || square == Line::LL){
                count++;
                y2 = y;
                x2 = x - 1;
                dir = Direction::Left;
            }
        }
        if (x < xsize - 1){
            auto &square = board[y][x + 1];
            if (square == Line::H || square == Line::UR || square == Line::LR){
                count++;
                y2 = y;
                x2 = x + 1;
                dir = Direction::Right;
            }
        }
        if (count == 1){ // 1{oĂƂ
            /* HĂAʂ̏ꏊ̓ɌqĂ邩`FbN */
            bool loopflag = true; // [v𑱂邩ǂ̃tO
            while (loopflag){
                if (!(y2 > -1 && y2 < ysize && x2 > -1 && x2 < xsize)) return false;
                switch(board[y2][x2]){ // HĂ̏ꏊ
                case Line::V:
                    if (dir == Direction::Upper){
                        y2--;
                    }else if (dir == Direction::Lower){
                        y2++;
                    }
                    break;
                case Line::H:
                    if (dir == Direction::Left){
                        x2--;
                    }else if (dir == Direction::Right){
                        x2++;
                    }
                    break;
                case Line::UL:
                    if (dir == Direction::Upper){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::UR:
                    if (dir == Direction::Upper){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::LL:
                    if (dir == Direction::Lower){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::LR:
                    if (dir == Direction::Lower){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::None:
                    return false;
                    break;
                default: // ̂Ƃ
                    // ʂ̐ɌqĂƂ
                    if (board[y2][x2] != num) return false;
                    // ̐ɖ߂ĂƂ
                    if (y2 == y && x2 == x) return false;
                    loopflag = false;
                    break;
                }
            }
        }else{ // oĂ̐1ȊÔƂ
            return false;
        }
    }
    return true;
}

/* \Ȏ̔ՖʑSĂi[L[Ԃ */
deque<NumberLinkBoard> NumberLink::getNextBoards(const NumberLinkBoard &board)
{
    deque<NumberLinkBoard> next_boards; // ̔Ֆʂi[L[
    /* SĂ̐ɂ */
    for (auto &place : places){
        const int y = place.second.first;
        const int x = place.second.second;
        Direction dir; // H
        int y2, x2; // ̎̏ꏊ
        int count = 0; // ̐oĂ̐
        if (y > 0){
            auto &square = board[y - 1][x];
            if (square == Line::V || square == Line::UL || square == Line::UR){
                count++;
                y2 = y - 1;
                x2 = x;
                dir = Direction::Upper;
            }
        }
        if (y < ysize - 1){
            auto &square = board[y + 1][x];
            if (square == Line::V || square == Line::LL || square == Line::LR){
                count++;
                y2 = y + 1;
                x2 = x;
                dir = Direction::Lower;
            }
        }
        if (x > 0){
            auto &square = board[y][x - 1];
            if (square == Line::H || square == Line::UL || square == Line::LL){
                count++;
                y2 = y;
                x2 = x - 1;
                dir = Direction::Left;
            }
        }
        if (x < xsize - 1){
            auto &square = board[y][x + 1];
            if (square == Line::H || square == Line::UR || square == Line::LR){
                count++;
                y2 = y;
                x2 = x + 1;
                dir = Direction::Right;
            }
        }
        if (count == 0){ // oĂȂƂ
            /* \Ȏ̏ʂ𐶐A[ɈᔽĂȂ΃L[Ɋi[ */
            if (y > 0 && board[y - 1][x] == Line::None){
                NumberLinkBoard next = board;
                array<Line, 3> next_lines = {{Line::V, Line::UL, Line::UR}};
                for (auto &next_line : next_lines){
                    next[y - 1][x] = next_line;
                    node_num++;
                    if (checkCompliance(next)) next_boards.push_back(next);
                }
            }
            if (y < ysize - 1 && board[y + 1][x] == Line::None){
                NumberLinkBoard next = board;
                array<Line, 3> next_lines = {{Line::V, Line::LL, Line::LR}};
                for (auto &next_line : next_lines){
                    next[y + 1][x] = next_line;
                    node_num++;
                    if (checkCompliance(next)) next_boards.push_back(next);
                }
            }
            if (x > 0 && board[y][x - 1] == Line::None){
                NumberLinkBoard next = board;
                array<Line, 3> next_lines = {{Line::H, Line::UL, Line::LL}};
                for (auto &next_line : next_lines){
                    next[y][x - 1] = next_line;
                    node_num++;
                    if (checkCompliance(next)) next_boards.push_back(next);
                }
            }
            if (x < xsize - 1 && board[y][x + 1] == Line::None){
                NumberLinkBoard next = board;
                array<Line, 3> next_lines = {{Line::H, Line::UR, Line::LR}};
                for (auto &next_line : next_lines){
                    next[y][x + 1] = next_line;
                    node_num++;
                    if (checkCompliance(next)) next_boards.push_back(next);
                }
            }
        }else if (count == 1){ // 1{oĂƂ
            /* HĂAʂ̐ɌqĂȂ`FbN */
            bool loopflag = true; // [v𑱂邩ǂ̃tO
            NumberLinkBoard next = board;
            array<Line, 3> next_lines;
            while (loopflag){
                if (!(y2 > -1 && y2 < ysize && x2 > -1 && x2 < xsize)) break;
                switch(board[y2][x2]){ // HĂ̏ꏊ
                case Line::V:
                    if (dir == Direction::Upper){
                        y2--;
                    }else if (dir == Direction::Lower){
                        y2++;
                    }
                    break;
                case Line::H:
                    if (dir == Direction::Left){
                        x2--;
                    }else if (dir == Direction::Right){
                        x2++;
                    }
                    break;
                case Line::UL:
                    if (dir == Direction::Upper){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::UR:
                    if (dir == Direction::Upper){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::LL:
                    if (dir == Direction::Lower){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::LR:
                    if (dir == Direction::Lower){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::None:
                    /* \Ȏ̏ʂ𐶐A[ɈᔽĂȂ΃L[Ɋi[ */
                    switch (dir){ // ŌɒHĂ
                    case Direction::Upper:
                        next_lines = {{Line::V, Line::UL, Line::UR}};
                        for (auto &next_line : next_lines){
                            next[y2][x2] = next_line;
                            node_num++;
                            if (checkCompliance(next)) next_boards.push_back(next);
                        }
                        break;
                    case Direction::Lower:
                        next_lines = {{Line::V, Line::LL, Line::LR}};
                        for (auto &next_line : next_lines){
                            next[y2][x2] = next_line;
                            node_num++;
                            if (checkCompliance(next)) next_boards.push_back(next);
                        }
                        break;
                    case Direction::Left:
                        next_lines = {{Line::H, Line::UL, Line::LL}};
                        for (auto &next_line : next_lines){
                            next[y2][x2] = next_line;
                            node_num++;
                            if (checkCompliance(next)) next_boards.push_back(next);
                        }
                        break;
                    case Direction::Right:
                        next_lines = {{Line::H, Line::UR, Line::LR}};
                        for (auto &next_line : next_lines){
                            next[y2][x2] = next_line;
                            node_num++;
                            if (checkCompliance(next)) next_boards.push_back(next);
                        }
                        break;
                    }
                    loopflag = false;
                    break;
                default: // ̂Ƃ
                    loopflag = false;
                    break;
                }
            }
        }
    }
    return next_boards;
}

/* A-starTɗpf(x)̒l擾 */
int NumberLink::getAStarValue(const NumberLinkBoard &board)
{
    int depth = 0; // ܂Ă}X̐=m[h̐[=g
    for (auto &row : board){
        for (auto &square : row){
            if (square < 0) depth++;
        }
    }
    int distance = 0; // h
    multimap<int, pair<int, int>> point_places; // e܂͐oĂ̐[̏ꏊi[multimap
    set<int> connected;// ɌqĂ鐔set
    int unlined_count = 0; // oĂȂ̐
    /* eoĂ̏ꏊpoint_placesɕۑAqĂ鐔connectedɒǉ */
    /* SĂ̐ɂ */
    for (auto &place : places){
        const int num = place.first;
        const int y = place.second.first;
        const int x = place.second.second;
        Direction dir; // H
        int y2, x2; // ̎̏ꏊ
        int count = 0; // ̐oĂ̐
        if (y > 0){
            auto &square = board[y - 1][x];
            if (square == Line::V || square == Line::UL || square == Line::UR){
                count++;
                y2 = y - 1;
                x2 = x;
                dir = Direction::Upper;
            }
        }
        if (y < ysize - 1){
            auto &square = board[y + 1][x];
            if (square == Line::V || square == Line::LL || square == Line::LR){
                count++;
                y2 = y + 1;
                x2 = x;
                dir = Direction::Lower;
            }
        }
        if (x > 0){
            auto &square = board[y][x - 1];
            if (square == Line::H || square == Line::UL || square == Line::LL){
                count++;
                y2 = y;
                x2 = x - 1;
                dir = Direction::Left;
            }
        }
        if (x < xsize - 1){
            auto &square = board[y][x + 1];
            if (square == Line::H || square == Line::UR || square == Line::LR){
                count++;
                y2 = y;
                x2 = x + 1;
                dir = Direction::Right;
            }
        }
        if (count == 0){ // oĂȂƂ
            point_places.insert(make_pair(num, make_pair(y, x)));
            unlined_count++;
        }else if (count == 1){ // 1{oĂƂ
            /* [܂ŒH */
            bool loopflag = true; // [v𑱂邩ǂ̃tO
            while (loopflag){
                if (!(y2 > -1 && y2 < ysize && x2 > -1 && x2 < xsize)) break;
                switch(board[y2][x2]){ // HĂ̏ꏊ
                case Line::V:
                    if (dir == Direction::Upper){
                        y2--;
                    }else if (dir == Direction::Lower){
                        y2++;
                    }
                    break;
                case Line::H:
                    if (dir == Direction::Left){
                        x2--;
                    }else if (dir == Direction::Right){
                        x2++;
                    }
                    break;
                case Line::UL:
                    if (dir == Direction::Upper){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::UR:
                    if (dir == Direction::Upper){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2++;
                        dir = Direction::Lower;
                    }
                    break;
                case Line::LL:
                    if (dir == Direction::Lower){
                        x2++;
                        dir = Direction::Right;
                    }else if (dir == Direction::Left){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::LR:
                    if (dir == Direction::Lower){
                        x2--;
                        dir = Direction::Left;
                    }else if (dir == Direction::Right){
                        y2--;
                        dir = Direction::Upper;
                    }
                    break;
                case Line::None:
                    // ̐[̏ꏊpoint_placesɒǉ
                    point_places.insert(make_pair(num, make_pair(y2, x2)));
                    loopflag = false;
                    break;
                default: // ̂Ƃ
                    // connectedɂ̐ǉ
                    if (num == board[y2][x2] && y2 != y && x2 != x) connected.insert(num);
                    loopflag = false;
                    break;
                }
            }
        }
    }
    /* e܂͐oĂ̐[m̃}nb^̑avZ */
    /* e܂͂oĂ̐[m̃}nb^̑áA܂ł̍ŒZoH̒̉E^ */
    while (!point_places.empty()){
        auto first = *(point_places.begin());
        point_places.erase(point_places.begin());
        const int num = first.first;
        auto second = *(point_places.find(num));
        // qĂȂ΁Ae܂͐oĂ̐[m̃}nb^distanceɑ
        if (connected.count(num) == 0) distance += abs(first.second.first - second.second.first) + abs(first.second.second - second.second.second);
    }
    // oĂȂ}nb^]ɐĂ̂ŁA̕
    distance -= unlined_count;
    // ̑g̐}nb^𐔂Ȃ̂ŁA̕𑫂
    distance += places.size() / 2;
    return depth + distance;
}

/* Ֆʂ\ */
void NumberLink::showBoard(const NumberLinkBoard &board)
{
    for (auto &row : board){
        for (auto &square : row){
            switch (square){ // }X̒g
            case Line::None:
                cout << " ";
                break;
            case Line::V:
                cout << "";
                break;
            case Line::H:
                cout << "";
                break;
            case Line::UL:
                cout << "";
                break;
            case Line::UR:
                cout << "";
                break;
            case Line::LL:
                cout << "";
                break;
            case Line::LR:
                cout << "";
                break;
            default: // ͂̂܂܏o
                cout << square;
                break;
            }
        }
        cout << endl;
    }
}

void NumberLink::showBoard(void)
{
    showBoard(initial_board);
}

int main()
{
    const vector<NumberLinkBoard> initial_boards = {{
            {
                {1, 0, 1},
            },
            {
                {1, 0, 1},
                {2, 0, 2},
                {0, 0, 0},
            },
            {
                {1, 0, 0, 0},
                {0, 0, 0, 1},
                {0, 0, 0, 0},
            },
            {
                {0, 0, 0, 0},
                {0, 0, 0, 1},
                {1, 0, 0, 0},
            },
            {
                {0, 0, 0, 0},
                {1, 0, 0, 1},
                {0, 0, 0, 0},
            },
            {
                {1, 0, 0, 1},
                {2, 0, 2, 3},
                {3, 0, 0, 0},
            },
            {
                {1, 0, 0, 0},
                {2, 0, 2, 0},
                {1, 0, 0, 0},
            },
            {
                {1, 0, 0, 0, 3},
                {2, 0, 2, 0, 0},
                {1, 0, 0, 0, 3},
            },
        }};
    for (NumberLinkBoard initial_board : initial_boards){
        NumberLink number_link(initial_board);
        cout << "ԁF\n";
        number_link.showBoard();
        cout << "[DTF" << number_link.solveDepthFirst() << endl;
        cout << "DTF" << number_link.solveBreadthFirst() << endl;
        cout << "A*TF" << number_link.solveAStar() << endl;
        cout << endl;
    }
    return 0;
}
