#include <iostream>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>

/* pY̒Ts߂̃ev[gNX */
template <typename Board>
class Puzzle{
private:
    // Ֆʂ[ɈᔽĂȂ
    virtual bool checkCompliance(const Board &board) = 0;
    // ՖʂĂ邩
    virtual bool checkSolved(const Board &board) = 0;
    // \Ȏ̔ՖʑSĂi[L[Ԃ
    virtual std::deque<Board> getNextBoards(const Board &board) = 0;
    // A-starTɗpf(x)̒l擾
    virtual int getAStarValue(const Board &board) = 0;
protected:
    int node_num; // WJm[h̐
    Board initial_board; // ̔Ֆ
public:
    // ̔Ֆʂpď
    Puzzle(const Board &initial_board) :
        node_num(1), initial_board(initial_board){};
    // Ֆʂ\
    virtual void showBoard(void) = 0;
    virtual void showBoard(const Board &board) = 0;
    // [DTŖAWJm[hԂ
    int solveDepthFirst(void);
    // DTŖAWJm[hԂ
    int solveBreadthFirst(void);
    // A-starTŖAWJm[hԂ
    int solveAStar(void);
};

/* [DTŖAWJm[hԂ */
template <typename Board>
int Puzzle<Board>::solveDepthFirst(void)
{
    node_num = 1; // WJm[h

    /* Ԃ[ᔽĂAɉĂTI */
    if (!checkCompliance(initial_board)){
        std::cout << "Ԃ[ᔽĂ܂\n";
        return node_num;
    }
    if (checkSolved(initial_board)){
        std::cout << "ԂɉĂ܂\n";
        return node_num;
    }
    std::deque<Board> open = {initial_board}; // WJ̃m[hi[L[
    std::stack<Board, std::deque<Board>> open_stack{open}; // WJ̃m[hi[L[pLIFOX^bN
    std::set<Board> closed; // WJς݂̃m[hi[Zbg
    /* X^bNpĐ[DT*/
    while (!open_stack.empty()){
        /* WJ̃m[hopenoAclosedɒǉ */
        const Board board = open_stack.top();
        open_stack.pop();
        closed.insert(board);
        /* \Ȏ̔ՖʑSĂɂ */
        for (auto &next : getNextBoards(board)){
            if (checkSolved(next)){ // ̔ՖʂڕWԂ̂Ƃ
                /* \ďI */
                std::cout << "\nF\n";
                showBoard(next);
                return node_num;
            }
            // ̔ՖʂclosedɊ܂܂ĂȂƂAX^bNɊi[
            if (closed.count(next) == 0) open_stack.push(next);
        }
    }
    std::cout << "܂ł\n";
    return node_num;
}

/* DTŖAWJm[hԂ */
template <typename Board>
int Puzzle<Board>::solveBreadthFirst(void)
{
    node_num = 1; // WJm[h

    /* Ԃ[ᔽĂAɉĂTI */
    if (!checkCompliance(initial_board)){
        std::cout << "Ԃ[ᔽĂ܂\n";
        return node_num;
    }
    if (checkSolved(initial_board)){
        std::cout << "ԂɉĂ܂\n";
        return node_num;
    }
    std::deque<Board> open = {initial_board}; // WJ̃m[hi[L[
    std::queue<Board, std::deque<Board>> open_queue{open}; // WJ̃m[hi[L[pFIFOL[
    std::set<Board> closed; // WJς݂̃m[hi[Zbg
    /* X^bNpĐ[DT*/
    while (!open_queue.empty()){
        /* WJ̃m[hopenoAclosedɒǉ */
        const Board board = open_queue.front();
        open_queue.pop();
        closed.insert(board);
        /* \Ȏ̔ՖʑSĂɂ */
        for (auto &next : getNextBoards(board)){
            if (checkSolved(next)){ // ̔ՖʂڕWԂ̂Ƃ
                /* \ďI */
                std::cout << "\nF\n";
                showBoard(next);
                return node_num;
            }
            // ̔ՖʂclosedɊ܂܂ĂȂƂAL[Ɋi[
            if (closed.count(next) == 0) open_queue.push(next);
        }
    }
    std::cout << "܂ł\n";
    return node_num;
}

/* A-starTŖAWJm[hԂ */
template <typename Board>
int Puzzle<Board>::solveAStar(void)
{
    node_num = 1; // WJm[h

    /* Ԃ[ᔽĂAɉĂTI */
    if (!checkCompliance(initial_board)){
        std::cout << "Ԃ[ᔽĂ܂\n";
        return node_num;
    }
    if (checkSolved(initial_board)){
        std::cout << "ԂɉĂ܂\n";
        return node_num;
    }
    std::multimap<int, Board> open = {{getAStarValue(initial_board), initial_board}}; // WJ̃m[hi[multimap
    std::set<Board> closed; // WJς݂̃m[hi[Zbg
    /* X^bNpĐ[DT*/
    while (!open.empty()){
        /* WJ̃m[hopenoAclosedɒǉ */
        const Board board = open.begin()->second;
        open.erase(open.begin());
        closed.insert(board);
        /* \Ȏ̔ՖʑSĂɂ */
        for (auto &next : getNextBoards(board)){
            if (checkSolved(next)){ // ̔ՖʂڕWԂ̂Ƃ
                /* \ďI */
                std::cout << "\nF\n";
                showBoard(next);
                return node_num;
            }
            // ̔ՖʂclosedɊ܂܂ĂȂƂAL[Ɋi[
            if (closed.count(next) == 0) open.insert(std::make_pair(getAStarValue(next), next));
        }
    }
    std::cout << "܂ł\n";
    return node_num;
}
